import scrapy
from scrapy.utils.project import get_project_settings
from ..helpers import CompanyMaker, Database

db_settings = get_project_settings().get('DB')
db = Database(**db_settings)


class BaseSpider(scrapy.Spider):
    def __init__(self, query=None, fresh=True, *args, **kwargs):
        super(BaseSpider, self).__init__(*args, **kwargs)
        self.condition = query
        self.fresh = False if fresh == 'False' else fresh
        self.query = "SELECT id, name, country FROM wp_esi_entity WHERE 1 and id=0"
        if self.condition:
            print(self.condition)
            self.query += ' or {}'.format(self.condition)

    def get_common_items(self, company):
        return {'region_id': company.region_id, 'type_id': company.type_id,
                'media_id': company.media_id, 'company_id': company.id}

    def companies(self, name):
        companies = CompanyMaker(db.select(self.query))
        companies.make_companies(name)
        return companies.get_companies()

    def can_follow(self, next_url, duplicate):
        if (next_url and not duplicate) or self.fresh is False:
            return True
        else:
            return False
